using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace quaqPack {
    public class quaqPack {
        public static void Main() {

            //Test Duck
            ModAPI.Register(
                new Modification() {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Murderous Ducky <QP>",
                    NameToOrderByOverride = "Duckqp",
                    DescriptionOverride = "Don't feed it after midnight. Actually, don't feed it at all.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("murderDuckView.png", 0.5f),
                    AfterSpawn = (Instance) => {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("murderDuck.png", 4f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 40f;
                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("squeak.wav")};
                        BoxCollider2D cld = Instance.GetComponent<BoxCollider2D>();
                        Rigidbody2D rb = Instance.GetComponent<PhysicalBehaviour>().rigidbody;

                        cld.size = new Vector2(0.23f, 0.06f);
                        cld.offset = new Vector2(0f, -0.04f);

                        PhysicsMaterial2D mat = new PhysicsMaterial2D();
                        mat.bounciness = 0.75f;
                        
						Instance.transform.localScale = new Vector3(Instance.transform.localScale.x*-1f, Instance.transform.localScale.y, Instance.transform.localScale.z);

                        BoxCollider2D cld2 = Instance.AddComponent<BoxCollider2D>();
                        cld2.size = new Vector2(0.055f,0.055f);
                        cld2.offset = new Vector2(-0.1f,0.06f);

                        cld.sharedMaterial = mat;
                        cld2.sharedMaterial = mat;

                        //Instance.FixColliders();

                        float fforce = 30;
                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            Rigidbody2D localHead = GameObject.Find("Head").GetComponent<Rigidbody2D>();
                            if(localHead) {
                                rb.AddForce((localHead.position - rb.position) * fforce, ForceMode2D.Impulse);
                            }
                        };
                        
                        ModAPI.OnDeath += (sender, being) => {
                            if(rb.velocity.magnitude > 15f) {
                                Instance.transform.localScale *= 1.5f;
                                rb.mass *= 1.5f;
                                fforce *= 1.5f;
                            }
                        };
                    }

                }
            );

            ModAPI.OnItemSelected += (sender, being) =>{
                //EvalThreat E = being.gameObject.AddComponent<EvalThreat>() as EvalThreat;
                /*
                //ModAPI.Notify(being.transform.parent.name);

                //EvalThreat E = being.gameObject.AddComponent<EvalThreat>() as EvalThreat;
                CatalogBehaviour[] bTypes = GameObject.FindObjectsOfType<CatalogBehaviour>();
                //Debug.Log(being.Catagory);
                foreach(CatalogBehaviour b in bTypes) {
                    SpawnableAsset[] sb = b.Catalog.Items;
                    foreach(SpawnableAsset SA in sb) {
                        Debug.Log(SA.Category);
                        Debug.Log(SA.Prefab.name);
                    }
                }
                */

            };
 
            ModAPI.Register(
                new Modification() {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Active Human STABLE<QP>",
                    NameToOrderByOverride = "!QPHumanActive",
                    DescriptionOverride = "This ragdoll has been given a fully simulated consciousness and, by extention, sentience. Be nice. " ,
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("activeHuman.png", 0.5f),
                    //ThumbnailOverride = ModAPI.LoadSprite("murderDuckView.png", 0.5f),
                    AfterSpawn = (Instance) => {
                        //AudioSource aS = Instance.AddComponent<AudioSource>();
                        //aS.clip = ModAPI.LoadSound("putin.wav");
                        ActiveHuman AH = Instance.AddComponent<ActiveHuman>();
                        AH.doEXP = false;
                    }

                }
            );

            ModAPI.Register(
                new Modification() {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Active Human EXPERIMENTAL<QP> ",
                    NameToOrderByOverride = "!QPHumanActiveNLQP",
                    DescriptionOverride = "This ragdoll has been given a fully simulated consciousness and, by extention, sentience. Be nice. \n\nExperimental features, such as the custom head solution, will now be tested on this version",
                    CategoryOverride = ModAPI.FindCategory("no"),
                    ThumbnailOverride = ModAPI.LoadSprite("activeHumanEXP.png", 0.5f),
                    //ThumbnailOverride = ModAPI.LoadSprite("murderDuckView.png", 0.5f),
                    AfterSpawn = (Instance) => {
                        //AudioSource aS = Instance.AddComponent<AudioSource>();
                        //aS.clip = ModAPI.LoadSound("putin.wav");
                        ActiveHuman AH = Instance.AddComponent<ActiveHuman>();  
                        AH.doEXP = true;
                        
                    }

                }
            );
            
            ModAPI.Register(
                new Modification() {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Quick Respawn Entities <QP>",
                    NameToOrderByOverride = "!QPquickrespawn",
                    DescriptionOverride = "Spawn this object and the script will be active until map change/game restart :> \n Press H to quick spawn last used entity on cursor.",
                    CategoryOverride = ModAPI.FindCategory("no"),
                    ThumbnailOverride = ModAPI.LoadSprite("QuickSpawn.png", 0.5f),
                    AfterSpawn = (Instance) => {
                        //ModEntryBehaviour MEB = UnityEngine.GameObject.GetComponent<ModEntryBehaviour>();
                        Instance.GetComponent<SpriteRenderer>().enabled = false;
                        //UnityEngine.Object.Destroy(Instance.GetComponent<SpriteRenderer>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<PhysicalBehaviour>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<BoxCollider2D>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<Rigidbody2D>());
                        Instance.AddComponent<QuickSpawn>();
                    }

                }
            );

			//im lazy boy
			ModAPI.Register(
                new Modification() {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Auto Activate Humans + Quick Respawn Script <QP>",
                    NameToOrderByOverride = "!QPAutoActivate",
                    DescriptionOverride = "Spawn this object and the script will be active until map change/game restart :> \n All spawned humans will automatically become Active Humans",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("AutoActivate.png", 0.5f),
                    AfterSpawn = (Instance) => {
                        //ModEntryBehaviour MEB = UnityEngine.GameObject.GetComponent<ModEntryBehaviour>();
                        Instance.GetComponent<SpriteRenderer>().enabled = false;
                        //UnityEngine.Object.Destroy(Instance.GetComponent<SpriteRenderer>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<PhysicalBehaviour>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<BoxCollider2D>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<Rigidbody2D>());
                        QuickSpawn QS = Instance.AddComponent<QuickSpawn>();
						QS.doActivator = true;
                    }
                }
            );
            

        }
    }
}